﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;

namespace es.jutrera.logistic
{
    public static class ManejadorCadena
    {
        public static string QuitaAcentos(string cadena)
        {
            return cadena.Replace("á", "a")
                .Replace("à", "a")
                .Replace("ä", "a")
                .Replace("â", "a")
                .Replace("ã", "a")
                .Replace("é", "e")
                .Replace("é", "e")
                .Replace("ê", "e")
                .Replace("ë", "e")
                .Replace("í", "i")
                .Replace("ì", "i")
                .Replace("ï", "i")
                .Replace("î", "i")
                .Replace("ó", "o")
                .Replace("ò", "o")
                .Replace("ö", "o")
                .Replace("ô", "o")
                .Replace("õ", "o")
                .Replace("ú", "u")
                .Replace("ù", "u")
                .Replace("ü", "u")
                .Replace("û", "u")
                .Replace("Á", "A")
                .Replace("À", "A")
                .Replace("Ä", "A")
                .Replace("Â", "A")
                .Replace("Ã", "A")
                .Replace("É", "E")
                .Replace("É", "E")
                .Replace("Ê", "E")
                .Replace("Ë", "E")
                .Replace("Í", "I")
                .Replace("Ì", "I")
                .Replace("Ï", "I")
                .Replace("Î", "I")
                .Replace("Ó", "O")
                .Replace("Ò", "O")
                .Replace("Ö", "O")
                .Replace("Ô", "O")
                .Replace("Õ", "O")
                .Replace("Ú", "U")
                .Replace("Ù", "U")
                .Replace("Ü", "U")
                .Replace("Û", "U");
        }

        internal static string BuildOutString(Elements item, bool names)
        {
            string cad_format = "{0:0.################}";
            CultureInfo enEN = CultureInfo.CreateSpecificCulture("en-EN");
            StringBuilder builder = new StringBuilder();
            if (names)
            {
                builder.Append(item.OldName);
                builder.Append("|");
                builder.Append(item.NewName);
                builder.Append("|");
            }
            builder.AppendFormat(enEN, cad_format, item.Levenshtein);
            builder.Append("|");
            builder.AppendFormat(enEN, cad_format, item.JaroWinkler);
            builder.Append("|");
            builder.Append(item.IsSame);

            string res = builder.ToString();

            builder = null;

            return res;
        }
    }

}
