﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace es.jutrera.logistic
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Setting up the data for the train process (please wait)");
            SetUpData(@"..", "source");
            SetUpData(@"..", "cross");
            SetUpData(@"..", "test");
            Console.WriteLine("dataset is already prepared.");
            Console.WriteLine("Press ENTER when the training is complete");
            Console.ReadLine();
        }

        /// <summary>
        /// Process the datasource appliying distance algorithms and stores the
        ///  result in a file in the same path indicated
        /// </summary>
        /// <param name="path">path of the datasource and results file</param>
        /// <param name="filename">name of the datasource file</param>
        private static void SetUpData(string path, string filename)
        {
            string ruta = path + "\\" + filename + ".csv";
            List<Elements> lista = new List<Elements>();
            StreamReader sr = new StreamReader(ruta);

            //Read the datasource and store in la List of Elements
            while (!sr.EndOfStream)
            {
                string[] data = sr.ReadLine().Split('|');

                lista.Add(new Elements()
                {
                    NewName = ManejadorCadena.QuitaAcentos(data[0]).Trim().ToUpper(),
                    OldName = ManejadorCadena.QuitaAcentos(data[1]).Trim().ToUpper(),
                    IsSame = Convert.ToInt32(data[2])
                });
            }
            sr.Close();

            //Appliying the distance algorithms
            lista.ForEach(item => DistanceAlgorithms.ApplyAlgorithms(item));
            
            //Displaying the results
            string salida = path + "\\train\\" + filename + ".out";
            
            StreamWriter sw = new StreamWriter(salida, false);

            lista.ForEach(item => sw.WriteLine(ManejadorCadena.BuildOutString(item, false).Replace(",", ".").Replace("|", ",")));
            
            sw.Flush();
            sw.Close();
        }
    }
}
